## com.saxonica.codegen
Class SequenceExpressionCompiler

    java.lang.Object
      com.saxonica.codegen.ExpressionCompiler
          com.saxonica.codegen.SequenceExpressionCompiler

Direct Known Subclasses:
  AtomicMappingCompiler, AtomicSequenceConverterCompiler, AtomizerCompiler, AxisExpressionCompiler, CardinalityCheckerCompiler, CollectionCompiler, ConditionalSorterCompiler, DistinctValuesCompiler, DocumentSorterCompiler, ExtensionFunctionCallCompiler, FilterExpressionCompiler, ForExpressionCompiler, IdCompiler, IdrefCompiler, IndexedFilterExpressionCompiler, IndexOfCompiler, InScopePrefixesCompiler, InsertCompiler, ItemCheckerCompiler, KeyFnCompiler, LazyExpressionCompiler, LetExpressionCompiler, LocalVariableReferenceCompiler, NumericPromoterCompiler, PathExpressionCompiler, RangeExpressionCompiler, RemoveCompiler, ReverseCompiler, SlashExpressionCompiler, StringToCodepointsCompiler, SubsequenceCompiler, TailCallLoopCompiler, TailExpressionCompiler, TokenizeCompiler, TupleSorterCompiler, UntypedAtomicConverterCompiler, UserFunctionCallCompiler, VariableReferenceCompiler, VennExpressionCompiler

    public abstract class SequenceExpressionCompiler

extends ExpressionCompiler

Superclass for compiling expressions whose natural evaluation mode is "pull", for example, expressions that read and return existing nodes.

Constructor Summary
`SequenceExpressionCompiler()`

Method Summary
`void` `compilePush(CompilerService compiler, Expression exp)` Generate Java code to execute the expression in push mode, that is, code to write events to the current output Receiver
`java.lang.String` `compileToCharSequence(CompilerService compiler, Expression exp)` Generate Java code to evaluate the expression as a CharSequence
`java.lang.String` `compileToEffectiveBooleanValue(CompilerService compiler, Expression expr, ReturnAction result)` Generate Java code to evaluate the effective boolean value of the expression
`java.lang.String` `compileToItem(CompilerService compiler, Expression exp)` Generate Java code to evaluate the expression as an Item

Methods inherited from class com.saxonica.codegen.ExpressionCompiler
`compileAsLoop, compileToIterator, compileToValueRepresentation`

Methods inherited from class java.lang.Object
`clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

Constructor Detail

### SequenceExpressionCompiler

    public SequenceExpressionCompiler()

Method Detail

### compileToItem

    public java.lang.String compileToItem(CompilerService compiler,
                                          Expression exp)

  Description copied from class: `ExpressionCompiler`
  Generate Java code to evaluate the expression as an Item

  Specified by:
    `compileToItem` in class `ExpressionCompiler`
  Parameters:
    `compiler` - the compiler service
    `exp` - the expression to be compiled
  Returns:
    a simple Java expression (usually the name of a variable that has been declared) which will be of class `Item`, and which will hold the value of the expression at run-time (or hold null, representing an empty sequence).

### compileToEffectiveBooleanValue

    public java.lang.String compileToEffectiveBooleanValue(CompilerService compiler,
                                                           Expression expr,
                                                           ReturnAction result)

  Description copied from class: `ExpressionCompiler`
  Generate Java code to evaluate the effective boolean value of the expression

  Specified by:
    `compileToEffectiveBooleanValue` in class `ExpressionCompiler`
  Parameters:
    `compiler` - the compiler service
    `expr` - the XPath expression to be compiled
    `result` - indicates how the boolean result is to be returned
  Returns:
    the result depends on the supplied value of the options argument. If options is a JavaDeclaration, the code must declare a Java variable and return the name of this variable. If options is a JavaAssignment, the code must assign the value to an existing Java variable. If options is a Return, the code must generate a return statement that returns the value of the boolean (in which case the result of this method is null).

### compilePush

    public void compilePush(CompilerService compiler,
                            Expression exp)

  Description copied from class: `ExpressionCompiler`
  Generate Java code to execute the expression in push mode, that is, code to write events to the current output Receiver

  Specified by:
    `compilePush` in class `ExpressionCompiler`
  Parameters:
    `compiler` - the compiler service
    `exp` - the expression to be compiled

### compileToCharSequence

    public java.lang.String compileToCharSequence(CompilerService compiler,
                                                  Expression exp)

  Description copied from class: `ExpressionCompiler`
  Generate Java code to evaluate the expression as a CharSequence

  Specified by:
    `compileToCharSequence` in class `ExpressionCompiler`
  Parameters:
    `compiler` - the compiler service
    `exp` - the XPath expression to be compiled
  Returns:
    a simple Java expression (usually the name of a variable that has been declared, or a string literal) which will be of class `CharSequence`, and which will hold the string value of the XPath expression at run-time

Copyright (c) Saxonica Limited. All rights reserved.